<?php
require_once(dirname(dirname(dirname(dirname(dirname(dirname(dirname(__FILE__))))))) . '/bitkassa/bitcoin_payment.php');
class BitKassa_BitKassa_Model_Bitcoin extends Mage_Payment_Model_Method_Abstract
{   
    protected $_code = 'bitkassa';
    protected $_isGateway               = TRUE;
    protected $_canAuthorize            = TRUE;
    protected $_canUseCheckout          = TRUE;
    protected $_canCapture              = TRUE;
    protected $_canUseInternal          = TRUE;
    protected $_canUseForMultishipping  = TRUE;
    protected $_canRefund               = FALSE;   
   
    public function getOrderPlaceRedirectUrl()
    {
        return Mage::getUrl('bitkassa/bitcoin/payment');
    }

    public function getPaymentById ($transaction_id) {
        if (!empty($transaction_id)) {
             $db = Mage::getSingleton('core/resource')->getConnection('core_read');
            $prefix = Mage::getConfig()->getTablePrefix();
            $sql = sprintf(
                    "SELECT *
                     FROM `%sbitkassa_bitcoin_transactions`
                     WHERE `transaction_id` = %s", 
                     $prefix, $db->quote($transaction_id)
                    );
           $q = $db->fetchAll($sql);           
           if (count($q) > 0) {
               return $q[0];
           }
        }
        return false;
    }

     public function setPayment ($order_id, $transaction_id) {
        if (!empty($order_id) && !empty($transaction_id)) {      
            $db = Mage::getSingleton('core/resource')->getConnection('core_write');
            $prefix = Mage::getConfig()->getTablePrefix();           
            $q = $db->query(
                sprintf(
                    "INSERT INTO `%sbitkassa_bitcoin_transactions` (`order_id` ,`transaction_id`, `status`)
                     VALUES (%s, %s, '%s')",
                     $prefix, $db->quote($order_id),$db->quote($transaction_id), 'open'
                )
            );
            
            if (count($q) > 0) {
                return true;
            }
        }
        return false;
    }
    
    public function updatePayment ($transaction_id, $status) {
        if (!empty($transaction_id) && !empty($status)) {
            $db = Mage::getSingleton('core/resource')->getConnection('core_write');
            $prefix = Mage::getConfig()->getTablePrefix();
            $q = $db->query(
                sprintf(
                    "UPDATE `%sbitkassa_bitcoin_transactions` 
                     SET `status` = %s 
                     WHERE `transaction_id` = %s;",
                     $prefix,
                   $db->quote($status),
                   $db->quote($transaction_id)
                )
            );
            if (count($q) > 0) {
                return true;
            }
        }
        return false;
    }
}
?>